Package org.eclipse.cdt.core.dom.ast

# Interface IASTTypeId

All Superinterfaces:
  `IASTNode`

All Known Subinterfaces:
  `IASTProblemTypeId`, `ICPPASTTypeId`

public interface IASTTypeId extends IASTNode

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`ABSTRACT_DECLARATOR`
`ABSTRACT_DECLARATOR` represents the relationship between an `IASTTypeId` and it's nested `IASTDeclarator`.
`static final ASTNodeProperty`
`DECL_SPECIFIER`
`DECL_SPECIFIER` represents the relationship between an `IASTTypeId` and it's nested `IASTDeclSpecifier`.
`static final IASTTypeId[]`
`EMPTY_TYPEID_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`IASTTypeId`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`IASTTypeId`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTDeclarator`
`getAbstractDeclarator()`
Get the abstract declarator.
`IASTDeclSpecifier`
`getDeclSpecifier()`
Returns the decl specifier.
`void`
`setAbstractDeclarator(IASTDeclarator abstractDeclarator)`
Sets the abstract declarator.
`void`
`setDeclSpecifier(IASTDeclSpecifier declSpec)`
Set the decl specifier.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### EMPTY_TYPEID_ARRAY

static final IASTTypeId[] EMPTY_TYPEID_ARRAY

### DECL_SPECIFIER

static final ASTNodeProperty DECL_SPECIFIER
`DECL_SPECIFIER` represents the relationship between an `IASTTypeId` and it's nested `IASTDeclSpecifier`.

### ABSTRACT_DECLARATOR

static final ASTNodeProperty ABSTRACT_DECLARATOR
`ABSTRACT_DECLARATOR` represents the relationship between an `IASTTypeId` and it's nested `IASTDeclarator`.

## Method Details

### getDeclSpecifier

IASTDeclSpecifier getDeclSpecifier()
Returns the decl specifier.

Returns:
  `IASTDeclSpecifier`

### setDeclSpecifier

void setDeclSpecifier(IASTDeclSpecifier declSpec)
Set the decl specifier.

Parameters:
  `declSpec` - `IASTDeclSpecifier`

### getAbstractDeclarator

IASTDeclarator getAbstractDeclarator()
Get the abstract declarator.

Returns:
  `IASTDeclarator`

### setAbstractDeclarator

void setAbstractDeclarator(IASTDeclarator abstractDeclarator)
Sets the abstract declarator.

Parameters:
  `abstractDeclarator` - `IASTDeclarator`

### copy

IASTTypeId copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

IASTTypeId copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3